// Delegate table for events
::eventsDelegate <- {

	addEffect = function(callback) {
		callbacks.push(callback)
		return this
	}

	removeEffect = function(callback = null) {
		if (runningEffects) callbacksToRemove.push(callback || currentCallback)
		else callbacks.remove(callbacks.find(callback))
		return this
	}

	triggerEffects = function(data = null) {
		runningEffects = true
		foreach (callback in callbacks) {
			currentCallback = callback
			callback(data)
		}
		currentCallback = null
		runningEffects = false
		foreach (callback in callbacksToRemove) callbacks.remove(callbacks.find(callback))
		callbacksToRemove = []
		return this
	}

}

// Event instance creator
::createEvent <- function() {

	local event = {
		callbacks = []
		callbacksToRemove = []
		currentCallback = null
		runningEffects = false
	}.setdelegate(::eventsDelegate)

	return event

}

::gameEvents <- {}
// Get an instance that listens to game events
::getEvent <- function(name) {
	if (!(name in ::gameEvents)) {
		::gameEvents[name] <- {}
		::gameEvents[name].event <- ::createEvent()
		::gameEvents[name]["OnGameEvent_"+name] <- @[::gameEvents[name]](info) event.triggerEffects(info)
		__CollectGameEventCallbacks(::gameEvents[name])
	}
	return ::gameEvents[name].event
}

// Notify an entity that it took damage.
__CollectGameEventCallbacks(::onTakeDamageScope <- {
	OnScriptHook_OnTakeDamage = function(info) {
		info.const_entity.ValidateScriptScope()
		local scope = info.const_entity.GetScriptScope()
		if ("handleDamage" in scope) scope.handleDamage(info)
	}
})